package com.gic.haoban.manage.web.utils;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.alibaba.fastjson.JSONObject;
import com.gic.redis.data.util.GicRateLimiter;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import com.gic.commons.util.IPUtil;

public class LogInterceptor extends HandlerInterceptorAdapter {

    private static final Logger log = LogManager.getLogger(LogInterceptor.class);

    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object object) throws Exception {
        String uri = request.getRequestURI();
        Map<String, String[]> parameterMap = request.getParameterMap();
        String enterpriseId = request.getParameter("enterpriseId");
        //限流代码
        long limiter = GicRateLimiter.getInstance("haoban-manage3-wx").acquire(uri,enterpriseId);
        if (limiter == 0L) {
            response.setContentType("application/json; charset=utf-8");
            JSONObject res = new JSONObject();
            res.put("errcode", -1024);
            res.put("errmsg", "当前访问用户较多，请稍后再试！");
            response.getWriter().write(res.toString());
            return false;
        }
        String ip = null;
        try {
            ip = IPUtil.getIpAddr(request);
        } catch (Exception e) {
        }
        log.info("请求参数,ip={},url={},参数={}", ip, uri, parameterMap);
        return true;
    }
}
